"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var tap_1 = __importDefault(require("tap"));
var lib_1 = require("../../lib");
tap_1.default.test('should compile a string with format: date', function (test) { return __awaiter(void 0, void 0, void 0, function () {
    var encoding;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, lib_1.compileSchema({
                    type: 'string',
                    format: 'date'
                })];
            case 1:
                encoding = _a.sent();
                test.strictSame(encoding, {
                    type: 'string',
                    encoding: 'RFC3339_DATE_INTEGER_TRIPLET',
                    options: {}
                });
                test.end();
                return [2];
        }
    });
}); });
tap_1.default.test('should compile a boolean schema true', function (test) { return __awaiter(void 0, void 0, void 0, function () {
    var encoding;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, lib_1.compileSchema(true)];
            case 1:
                encoding = _a.sent();
                test.strictSame(encoding, {
                    type: 'any',
                    encoding: 'ANY_PACKED_TYPE_TAG_BYTE_PREFIX',
                    options: {}
                });
                test.end();
                return [2];
        }
    });
}); });
tap_1.default.test('should compile a simple oneOf schema', function (test) { return __awaiter(void 0, void 0, void 0, function () {
    var encoding;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, lib_1.compileSchema({
                    oneOf: [
                        {
                            type: 'integer'
                        },
                        {
                            minimum: 2
                        }
                    ]
                })];
            case 1:
                encoding = _a.sent();
                test.strictSame(encoding, {
                    type: 'oneOf',
                    encoding: 'ONEOF_CHOICE_INDEX_PREFIX',
                    options: {
                        choices: [
                            {
                                schema: {
                                    type: 'integer',
                                    multipleOf: 1
                                },
                                encoding: {
                                    type: 'integer',
                                    encoding: 'ARBITRARY_MULTIPLE_ZIGZAG_VARINT',
                                    options: {
                                        multiplier: 1
                                    }
                                }
                            },
                            {
                                schema: {
                                    anyOf: [
                                        {
                                            minimum: 2,
                                            enum: [null]
                                        },
                                        {
                                            minimum: 2,
                                            enum: [false, true]
                                        },
                                        {
                                            type: 'object',
                                            additionalProperties: {},
                                            properties: {},
                                            required: [],
                                            minProperties: 0
                                        },
                                        {
                                            type: 'array',
                                            items: {},
                                            minItems: 0
                                        },
                                        {
                                            type: 'string',
                                            minLength: 0
                                        },
                                        {
                                            type: 'number',
                                            minimum: 2
                                        },
                                        {
                                            type: 'integer',
                                            minimum: 2,
                                            multipleOf: 1
                                        }
                                    ]
                                },
                                encoding: {
                                    type: 'any',
                                    encoding: 'ANY_PACKED_TYPE_TAG_BYTE_PREFIX',
                                    options: {}
                                }
                            }
                        ]
                    }
                });
                test.end();
                return [2];
        }
    });
}); });
